//
// Created by bbr on 05.06.22..
//

#ifndef SCHEMEEDITOR_SINGLE_AUTOMATIC_DIALOG_H
#define SCHEMEEDITOR_SINGLE_AUTOMATIC_DIALOG_H

#include <vector>
#include <QDialog>
#include <QVBoxLayout>
#include "comdel/domain/value.h"
#include "comdel/domain/instance_attribute.h"

namespace display {

    class SingleAutomaticDialog: public QDialog {
        domain::Value firstValue;
        domain::Value secondValue;
        std::vector<domain::InstanceAttribute> &attributes;

    public:
        explicit SingleAutomaticDialog(std::vector<domain::InstanceAttribute>& values, bool updating = true);

        void setupValues(QVBoxLayout *layout, domain::InstanceAttribute &attribute, void (display::SingleAutomaticDialog::* handler)(int));

    public slots:

        void onFirstEnumerationChanged(int index);
        void onSecondEnumerationChanged(int index);
        void onUpdate();
    };

} // display

#endif //SCHEMEEDITOR_SINGLE_AUTOMATIC_DIALOG_H
