#include "pin.h"

namespace domain {

    PinConnection::PinConnection(std::string message, ConnectionType type)
            : message(message), type(type) {}

    PinConnection::ConnectionType PinConnection::getType() {
        return type;
    }

    std::string PinConnection::getMessage() {
        return message;
    }


    Pin::Pin(std::string name, PinType type, std::string tooltip, PinConnection connection, domain::ui::Pin pin,
             std::optional<std::vector<Value>> wires)
            : name(name), type(type), tooltip(tooltip), connection(connection), displayPin(pin), wires(wires) {}

    std::string &Pin::getName() {
        return name;
    }

    Pin::PinType Pin::getType() {
        return type;
    }

    std::string Pin::getTooltip() {
        return tooltip;
    }

    ui::Pin &Pin::getDisplayPin() {
        return displayPin;
    }

    PinConnection &Pin::getConnection() {
        return connection;
    }

    std::optional<std::vector<Value>> &Pin::getWires() {
        return wires;
    }


} // namespace domain
